<template>
  <button
    :class="classes"
    v-bind="$attrs"
    :data-testid="text"
    v-on="$listeners"
    @click="onClick"
  >
    <sa-avatar v-if="avatar" size="small" :full-name="avatar" />
    <div v-if="iconRight">
        <span :class="iconOnly ? 'sr-only' : 'text'">{{ text }}</span>
        <sa-icon
          v-if="icon"
          :icon="icon"
          :size="iconOnly ? '2' : '1'"
          :spin="spin"
        />
    </div>
    <div v-else>
        <sa-icon
          v-if="icon"
          :icon="icon"
          :size="iconOnly ? '2' : '1'"
          :spin="spin"
        />
        <span :class="iconOnly ? 'sr-only' : 'text'">{{ text }}</span>
    </div>
  </button>
</template>

<script>
export default {
  name: 'SaButton',
  props: {
    /**
     * Display style of button
     * @values primary, secondary, danger
     */
    type: {
      type: String,
      default: 'primary'
    },
    /** @values small, regular, large */
    size: {
      type: String,
      default: 'regular'
    },
    /** Button label */
    text: {
      type: String,
      required: true
    },
    /** Name of icon to show in button. See `icon` component docs for available names. */
    icon: {
      type: String,
      default: ''
    },
    /** Show button with icon only. The `text` prop is still used for screen readers. */
    iconOnly: {
      type: Boolean,
      default: false
    },
    /** Show icon on the right-hand side of the text. */
    iconRight: {
      type: Boolean,
      default: false
    },
    /** Spin the icon. Useful as a loading indicator. */
    spin: {
      type: Boolean,
      default: false
    },
    /** Full name of a user to show an `avatar` in the button */
    avatar: {
      type: String,
      default: ''
    },
    /** ID of a `modal` to show/hide when clicking the button */
    modalId: {
      type: String,
      default: null
    }
  },
  data() {
    return {
      dropdownOpen: false,
      uniqueId: this.makeUniqueId()
    }
  },
  computed: {
    classes() {
      return ['button', this.type, this.size]
    }
  },
  methods: {
    async onClick() {
      if (this.modalId) {
        if (this.$listeners && this.$listeners.click) {
          // let other click handlers happen first, allowing two ticks to pass
          await this.$nextTick()
          await this.$nextTick()
        }
        this.$root.$emit('modal-toggle', this.modalId)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.button {
  border-radius: $border-radius;
  transition: $transition;
  &:hover:enabled,
  &:focus:enabled {
    box-shadow: $box-shadow;
  }
  &:disabled {
    cursor: not-allowed;
  }
}
.primary {
  background: color(primary);
  color: color(white);
  &:hover:enabled,
  &:focus:enabled {
    background: mix(white, color(primary), 20%);
  }
  &:disabled {
    color: color(grey);
    background: color(grey-tint);
  }
}
.secondary {
  background: color(primary-tint);
  color: color(primary-dark);
  &:hover:enabled,
  &:focus:enabled {
    background: mix(white, color(primary-tint), 20%);
  }
  &:disabled {
    color: color(grey);
    background: color(grey-tint);
  }
}
.danger {
  background: color(danger-dark);
  color: color(white);
  &:hover:enabled,
  &:focus:enabled {
    background: mix(white, color(danger-dark), 20%);
  }
  &:disabled {
    color: color(grey);
    background: color(danger-tint);
  }
}
</style>
